.MODEL Small
        .XCREF
        .XLIST
INCLUDE  DEFMS.ASM ; MACROs and MS-DOS definitions from Heath/Zenith software.
        .LIST
        .CREF

.386
.stack
.data
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; - - -  Data area for HNumDisp routine.  - - -
Labels  DB     'Bytes', 'KiB  ', 'MiB  ', 'GiB  ', 'TiB  ', 'PiB  ', 'EiB  '
Hundred DB     100
Ten     DW     10
;;HND_Int DD     0        ; temp storage?
;;HND_Fra DD     0
HND_Str DB     '     .        ', 13, 10, '$'; change last to $ for DOS, 0 for C
; - - -
.code
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Start:  ; Test our routine

        MOV     AX,SEG @DATA
        MOV     DS,AX
        MOV     ES,AX

        MOV     EDX,122
        MOV     EAX,0A5A5A5A5H
        CALL HNumDisp
        MOV     DX, OFFSET HND_Str
        SCALL OUTSTR    ; MS-DOS Print String Fn 9

        MOV     EDX,0
        MOV     EAX,0A5A5A5A5H
        CALL HNumDisp
        MOV     DX, OFFSET HND_Str
        SCALL OUTSTR

        MOV     EDX,0
        MOV     EAX,0
        CALL HNumDisp
        MOV     DX, OFFSET HND_Str
        SCALL OUTSTR

        MOV     EDX,0
        MOV     EAX,1023
        CALL HNumDisp
        MOV     DX, OFFSET HND_Str
        SCALL OUTSTR

        MOV     EDX,0
        MOV     EAX,1024
        CALL HNumDisp
        MOV     DX, OFFSET HND_Str
        SCALL OUTSTR

        MOV     EDX,0FFFFFFFFH
        MOV     EAX,0FFFFFFFFH
        CALL HNumDisp
        MOV     DX, OFFSET HND_Str
        SCALL OUTSTR

        MOV     EDX,0FFFFFFFH
        MOV     EAX,0FFFFFFFFH
        CALL HNumDisp
        MOV     DX, OFFSET HND_Str
        SCALL OUTSTR

        SCALL EXIT      ; MS-DOS Exit Fn 4CH

; - - - HNumDisp routine.  - - -
; Display a number in terms of 10 bit chunks (bytes, kiloytes, etc.).
; 31 July 2008, first attempt, SRN.
; 3 August 2008, bug fix, SRN.

; EDX:EAX has the number on input.
; HND_Str has a string on output.
HNumDisp:
        PUSHAD  ; Save all registers as we were asked to make an OS
                ; neutral routine.
        PUSHFD  ; And save state of direction flag?  (Nope)

; - - - test 63 - 60 bits - - - 'EiB  '
; Nybble counter     87654321
        TEST    EDX,0F0000000H  ; Test the high four bits.
        JZ      HND_1           ; If none set, go do it again.
        MOV     ECX,52  ; Shift count to get 18 bits to play with.
        MOV     EBX,30  ; Offset of label in Labels array.
        JMP     HND_18  ; Go to process the selected bits.

; - - - test 59 - 50 bits - - - 'PiB  '
HND_1:
        TEST    EDX,00FFC0000H
        JZ      HND_2
        MOV     ECX,42
        MOV     EBX,25
        JMP     HND_18

; - - - test 49 - 40 bits - - - 'TiB  '
HND_2:
        TEST    EDX,00003FF00H
        JZ      HND_3
        MOV     ECX,32
        MOV     EBX,20
        JMP     HND_18

; - - - test 39 - 30 bits - - - 'GiB  '
HND_3:
        TEST    EDX,0000000FFH  ; Lower eight from high DWORD.
        JNZ     HND_3a
        TEST    EAX,0C0000000H  ; Highest two from low DWORD.
        JZ      HND_4
HND_3a:
        MOV     ECX,22
        MOV     EBX,15
        JMP     HND_18

; - - - test 29 - 20 bits - - - 'MiB  '
HND_4:
; Nybble counter     87654321
        TEST    EAX,03FF00000H
        JZ      HND_5
        MOV     ECX,12
        MOV     EBX,10
        JMP     HND_18

; - - - test 19 - 10 bits - - - 'KiB  '
HND_5:
        TEST    EAX,0000FFC00H
        JZ      HND_6
        MOV     ECX,2
        MOV     EBX,5
        JMP     HND_18

; - - - End with 9 - 0 bits - - - 'Bytes'
HND_6:
        MOV     BL,' '  ; blank leading part of string
        MOV     [HND_Str],BL
        MOV     [HND_Str+1],BL
        MOV     [HND_Str+2],BL
        MOV     EBX,0   ; Point to proper label
        MOV     EDI,3   ; Offset for ten bit case with no fraction.

        JMP     HND_19

HND_18: ; - - - Convert eighteen bits to a display string.  - - -
;        SHRD    EAX,EDX,CL      ; Oh yeah?
                                 ; turns out to not do what I wanted.
        SHR     EDX,1           ; Shift EDX:EAX CL bits to the right.
        RCR     EAX,1
        LOOP    HND_18

        MOV     EDX,EAX         ; Save Int + Frac
        SHR     EDX,8           ; Discard Frac
        MUL     [Hundred]       ; Convert binary fraction
        MOV     AL,AH
        AAM
        ADD     AX,03030H       ; ASCIIize it
        MOV     [HND_Str+6],AH  ; And store into string.
        MOV     [HND_Str+7],AL
        MOV     AH,'.'
        MOV     [HND_Str+5],AH  ; And do the dot

        MOV     EAX,EDX         ; Get ten bits into (E)AX.
        MOV     EDI,0           ; Use zero offset for eighteen bit case.

HND_19: ; - - - Convert ten bits to a display string.  - - -

;        ADD     EDI,OFFSET HND_Str
        ADD     DI,OFFSET HND_Str ; MASM burped
        CMP     EAX,1000        ; Play with possible thousands digit
        JB      HND_20
        MOV     DX,',1'
        MOV     WORD PTR [EDI],DX
        SUB     EAX,1000
        JMP     HND_21
HND_20:
        MOV     DX,'  '
        MOV     WORD PTR [EDI],DX
; - - - Display a one, two, or three digit number  - - -
        XOR     EDX,EDX
        DIV     [Ten]           ; Divide (E)AX by ten
        ADD     DL,030H         ; ASCIIize it
        MOV     BYTE PTR [EDI+4],DL     ; Always display 1st digit
        OR      EAX,EAX         ; Is (E)AX empty?
        JZ      HND_20a         ; Print two blanks
        XOR     EDX,EDX
        DIV     [Ten]           ; get next digit
        ADD     DL,030H
        MOV     BYTE PTR [EDI+3],DL
        OR      EAX,EAX
        JZ      HND_20b         ; Print a blank
        XOR     EDX,EDX
        DIV     [Ten]
        ADD     DL,030H
        MOV     BYTE PTR [EDI+2],DL
        JMP     HND_22
HND_20a:
        MOV     DL,' '
        MOV     BYTE PTR [EDI+3],DL
HND_20b:
        MOV     DL,' '
        MOV     BYTE PTR [EDI+2],DL
        JMP     HND_22

HND_21: ; - - - Display a three digit number  - - -
        XOR     EDX,EDX
        DIV     [Ten]           ; Divide (E)AX by ten
        ADD     DL,030H         ; ASCIIize it
        MOV     BYTE PTR [EDI+4],DL ; Store in string.
        XOR     EDX,EDX         ; Do it again.
        DIV     [Ten]
        ADD     DL,030H
        MOV     BYTE PTR [EDI+3],DL
        XOR     EDX,EDX
        DIV     [Ten]
        ADD     DL,030H
        MOV     BYTE PTR [EDI+2],DL
HND_22: ; - - -  Label it  - - -
        MOV     EAX,DWORD PTR [EBX+Labels]
        MOV     DWORD PTR [HND_Str+9],EAX
        MOV     AL,[EBX+Labels+4]
        MOV     BYTE PTR [HND_Str+13],AL

; - - -  Restore stuff we saved, and return.  - - -

        POPFD
        POPAD
        RET

; - - -  HNumDisp ends  - - -
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
        END     Start
